# Offer Transaction Service

## Steps to install and run the application

Download and Install Postgress In Docker ::

```bash
docker pull postgres

docker run -d -e POSTGRES_USER=user -e POSTGRES_PASSWORD=password123 --name postgres -p 5432:5432  --restart=always postgres
```

Download and install pgadmin4 from below link

[PGAdmin4 ](https://www.postgresql.org/ftp/pgadmin/pgadmin4/v4.19/windows/)

after installation start the pg admin by use below url

```bash
http://127.0.0.1:58283/browser/#
```

Once you start it will ask to create a master password

Go to Add New Server --> Give any database name --> go to connection tab and provide below details

```bash
url: jdbc:postgresql://localhost:5432/storedb
username: postgres
password: dbpwd
```
Then click on save

In Header click on Tool -> Query Tool --> and paste the below query

```bash
-- Table: public.offer_lookup

-- DROP TABLE public.offer_lookup;

CREATE TABLE offer_lookup
( 
	id INTEGER,
	store_id VARCHAR(200),
	terminal VARCHAR(200),
	offer_type VARCHAR(200),
	offer_id INTEGER ,
	pre_condition VARCHAR (100),
	PRIMARY KEY(id, offer_type,offer_id)
);

TABLESPACE pg_default;

ALTER TABLE public.offer_lookup
    OWNER to "postgress";

```

```bash
Once you create use the below query to insert a data

INSERT INTO public.offer_lookup(
	 store_id, terminal, offer_type, offer_id, pre_condition, id)
	VALUES ('0001','001','Customer',1,'AND',54321);
INSERT INTO public.offer_lookup(
	store_id, terminal, offer_type, offer_id, pre_condition,id)
	VALUES ('0001','001','Customer',2,'AND',54321);
INSERT INTO public.offer_lookup(
	store_id, terminal, offer_type, offer_id, pre_condition,id)
	VALUES ('0001','001','Customer',3,'AND',54321);
INSERT INTO public.offer_lookup(
	store_id, terminal, offer_type, offer_id, pre_condition,id)
	VALUES ('0001','001','Customer',4,'AND',54321);

```

```bash
Create a table for end of sale

CREATE EXTENSION IF NOT EXISTS "uuid-ossp";

CREATE TABLE transaction_recorder(
  uuid uuid NOT NULL DEFAULT uuid_generate_v1(),
  offertransactionresponse jsonb NOT NULL,
  offers jsonb NOT NULL,
  isprocessed boolean
);

```

```bash
dummy data
==========


INSERT INTO transaction_recorder VALUES ( uuid_generate_v4()  ,
'{"name": "Paint house", "tags": ["Improvements", "Office"], "finished": true}',
'{"name": "Paint house", "tags": ["Improvements", "Office"], "finished": true}' );
```


## Create table offer metadata


```bash

-- Table: public.offer_metadata

-- DROP TABLE public.offer_metadata;

CREATE TABLE offer_metadata
(
	offer_id serial PRIMARY KEY,
	eligibilty VARCHAR(200),
	discount_type VARCHAR(200),
	status VARCHAR(50) NOT NULL,
	start_time VARCHAR(20),
	end_time VARCHAR(20),
	offer_desc VARCHAR (355),
	offer_type INTEGER,
	rcpt_text VARCHAR (200)
);

TABLESPACE pg_default;

ALTER TABLE public.offer_metadata
    OWNER to "user";



```





```bash
dummy data
==========

INSERT INTO public.offer_metadata(
	 offer_id, eligibility, discount_type, status, start_time,end_time,
	offer_desc,offer_type,rcpt_text)
	VALUES (1,'elgibility','dicounted','Active','2020-04-14 19:10:25','2020-04-15 19:10:25',
			'30 percent','5','RCPT TXT');

INSERT INTO public.offer_metadata(
	 offer_id, eligibility, discount_type, status, start_time,end_time,
	offer_desc,offer_type,rcpt_text)
	VALUES (2,'elgibility','dicounted','InActive','2020-04-14 19:10:25','2020-04-15 19:10:25',
			'20 percent','5','RCPT TXT');

INSERT INTO public.offer_metadata(
	 offer_id, eligibility, discount_type, status, start_time,end_time,
	offer_desc,offer_type,rcpt_text)
	VALUES (3,'elgibility','dicounted','Active','2020-04-15 19:10:25','2020-04-16 19:10:25',
			'10 percent','5','RCPT TXT');
INSERT INTO public.offer_metadata(
	 offer_id, eligibility, discount_type, status, start_time,end_time,
	offer_desc,offer_type,rcpt_text)
	VALUES (4,'elgibility','dicounted','Active','2020-04-1 19:10:25','2020-04-15 19:10:25',
			'05 percent','5','RCPT TXT');

```

