package com.nisum.offertransactionservice.dto;

import com.nisum.offertransactionservice.dto.Item;
import lombok.AccessLevel;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.experimental.FieldDefaults;

import javax.validation.Valid;
import javax.validation.constraints.NotNull;
import java.util.List;
import java.util.UUID;

import static com.google.common.collect.Lists.newArrayList;

@Data
@NoArgsConstructor
@AllArgsConstructor
@FieldDefaults(level = AccessLevel.PRIVATE, makeFinal = false)
public class OfferTransactionRequest {

    @NotNull
    Long hhId;

    String transactionId= UUID.randomUUID().toString();

    @Valid
    List<Item> itemList = newArrayList();
}
