package com.nisum.offertransactionservice.model;

import com.vladmihalcea.hibernate.type.json.JsonBinaryType;
import lombok.AccessLevel;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.experimental.FieldDefaults;
import org.hibernate.annotations.Type;
import org.hibernate.annotations.TypeDef;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.util.UUID;

@Data
@NoArgsConstructor
@AllArgsConstructor
@FieldDefaults(level = AccessLevel.PRIVATE, makeFinal = false)
@Entity
@Table(name = "transaction_recorder")
@TypeDef(
        name = "jsonb",
        typeClass = JsonBinaryType.class
)
public class EndOfSaleEntity {
    @Id
    @Column(name = "uuid")
    UUID uuid;
    @Type(type = "jsonb")
    @Column(name = "offertransactionresponse")
    String offerTransactionResponse;
    @Type(type = "jsonb")
    @Column(name = "offers")
    String offers;
    @Column(name = "isprocessed")
    Boolean isProcessed = Boolean.TRUE;
}
