package com.nisum.offertransactionservice.util;

import com.nisum.offertransactionservice.genericexception.GlobalApiGenericException;
import com.safeway.epe.model.Response;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.reactive.function.client.ClientResponse;
import reactor.core.publisher.Mono;


@Slf4j
public class ExceptionUtil {

    public static Mono<? extends Throwable> handleError(ClientResponse clientResponse)throws GlobalApiGenericException {
        final Mono<Response> responseMono = clientResponse.bodyToMono(Response.class);
        return  responseMono.flatMap(response -> {
            log.error("Error Response While Calling Service {}",response);
            throw new GlobalApiGenericException(response, response.getHttpStatusCode());
        });
    }
}
